<?php
function ShowTopic(){
  require 'TagFormat.php';
  if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента и статус
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat, mpp, status, admin FROM users WHERE iduser=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $mpp, $userstatus, $admin);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{ // если гостевой доступ
    $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
    $mpp = (int)$_COOKIE['mpp'];
    if (($mpp < 1) or ($mpp > 16777215)) $mpp = 20;
    if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
    $timeformat = 'H:i d.m.Y';
    $userstatus = 'guest'; //используем эту перемнную для условного обозначения гостей
  }

  if ($userstatus == 'guest'){ //если участник не залогинен (гостевой доступ)
    $msgid = (int)substr($_GET['msg'], 0, 7); // id сообщения
    if ($msgid > 0){

      $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_topic, deleted FROM posts WHERE id_msg=? LIMIT 1'); // проверка есть ли топик и не удалено ли сообщение
      mysqli_stmt_bind_param($stmt, 'i', $msgid); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $topicid, $deleted); 
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);

      if (!isset($deleted)){ //если сообщение удалено физически то берём номер топика из $_GET и ищем неудалённое сообщение с максимальным номером
        $topicid = (int)substr($_GET['id'], 0, 6); // id топика

        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT MAX(id_msg) FROM posts WHERE deleted=0 AND id_topic=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', $topicid); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $msgid); 
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");//переходим на это сообщение
        else header('Location: http://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");
        exit();
      }

      if (($deleted == 1) and (!empty($topicid))){ //если сообщение удалено, ищем неудалённое сообщение с максимальным номером
        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT MAX(id_msg) FROM posts WHERE deleted=0 AND id_topic=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', $topicid); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $msgid); 
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");//переходим на это сообщение
        else header('Location: http://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");
        exit();

      //  $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      //  <tr><td><div align="center">Сообщение удалено.</div></td></tr><tr><td height="10px"></td></tr></table>';
      //  return $html;
      }      

      if (empty($topicid)){ // если такого топика нет
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого сообщения нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
        return $html;
      }else{// если такой топик с таким сообщением есть выясняем номер страницы по порядковому номеру позиции сообщения в ленте топика
        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT COUNT(*) FROM posts WHERE deleted=0 AND id_topic=? AND id_msg<=? ORDER BY id_msg ASC');//выясняем порядковый номер
        mysqli_stmt_bind_param($stmt, 'ii', $topicid, $msgid);
        if(mysqli_stmt_execute($stmt)){ 
          mysqli_stmt_bind_result($stmt, $msgPos);
          mysqli_stmt_fetch($stmt);
        }
        mysqli_stmt_close($stmt);

        $page = ceil($msgPos / $mpp); //получили номер страницы по номеру сообщения
      }
    }else{//отображение контента по номеру сообщения и по номеру страницы независимы и могут быть взаимоисключающими
      $topicid = (int)substr($_GET['id'], 0, 6); // id топика
      if ($topicid <= 0){ //
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого контента нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
        return $html;
      }
      $page = (int)substr($_GET['page'], 0, 7); // номер страницы 
      if ($page <= 0) $page = 1;
    }

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT msgs, name, deleted FROM topics WHERE id_topic=?');
    mysqli_stmt_bind_param($stmt, 'i', $topicid); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $Totalmsgs, $name, $del); // получение количества сообщений всего, названия и проверка есть ли топик
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    if ($del == 1){
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Топик удалён.</div></td></tr><tr><td height="10px"></td></tr></table>';
      return $html;
    }

    if (empty($name)){
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Такого топика нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
      return $html;
    }

    $TotalPages = ceil($Totalmsgs / $mpp); //максимальный номер страницы = кол-во страниц
    if ($page > $TotalPages) $page = $TotalPages;
    if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка сообщений
      $Showmsgs = $Totalmsgs - (($TotalPages - 1) * $mpp);
    }else{ // если страница внутри итератора - длина списка равна настроечной
      $Showmsgs = $mpp;
    }
    $Offset = $mpp * ($page - 1);

    if ($TotalPages > 1){ //создаём итератор, только если страниц 2 и более
      require 'PageIteratorCreate.php';
      $PageIterator = PageIteratorCreate(27, $TotalPages, $page, './?ai=9&id='.$topicid.'&page='); //создаём html-код итератора страниц (ячейки таблицы)
      if ($page == $TotalPages){ //если текущая страница последняя показываем только стрелку "назад"
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Предыдущая страница" src="./pics/suda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page-1)."'".'" alt="Назад" style="display: block"></a></div>';
      }elseif ($page == 1){ //если текущая страница первая показываем только стрелку "вперёд"
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Следующая страница" src="./pics/tuda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=2'".'" alt="Вперёд" style="display: block"></a></div>';
      }else{//если текущая страница внутри диапазона
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Следующая страница" src="./pics/tuda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page+1)."'".'" alt="Вперёд" style="display: block"></a></div>'.
        '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Предыдущая страница" src="./pics/suda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page-1)."'".'" alt="Назад" style="display: block"></a></div>';
      }
    }else{
      $PageIterator = '';
      $PageNav = '';
    }

    $menu = '<table cellspacing="0" cellpadding="0" width="100%"><tr><td height="2px"></td></tr><tr><td>'.
    '<script>function setFontSizeCookie(fontSize){document.cookie = "fontSize=" + encodeURIComponent(fontSize) + "; expires=Fri, 31 Dec 9999 23:59:59 GMT; path=/";}
    
      function FontPlus(){var fontSizeCookie = getFontSizeFromCookie();
        var numericValue = parseInt(fontSizeCookie);
        numericValue += 1;
        var newFontSize = numericValue.toString() + "px";
        SetMessageFont(newFontSize);setFontSizeCookie(newFontSize);}
   
       function FontMinus(){var fontSizeCookie = getFontSizeFromCookie();
        var numericValue = parseInt(fontSizeCookie);
        numericValue -= 1;
        var newFontSize = numericValue.toString() + "px";
        SetMessageFont(newFontSize);setFontSizeCookie(newFontSize);}
      </script>'.
    '<div style="float: left"><a class="noneall" style="cursor:pointer">'.
    '<img title="Увеличить шрифт" src="./pics/Like.png" onclick="FontPlus()" alt="шрифт+" style="display: block"></a></div>'.
    '<div style="float: left"><a class="noneall" style="cursor:pointer">'.
    '<img title="Уменьшить шрифт" src="./pics/minus.png" onclick="FontMinus()" alt="шрифт-" style="display: block"></a></div>'.
    '<div style="float: left"><a class="noneall" style="cursor: pointer">'. 
    '<img title="Скачать топик" src="./pics/download.png" onclick="location.href='."'".'./dnldtopic.php?id='.$topicid."'".'" alt="Скачать" style="display: block"></a></div>'.
    $PageNav.'</td></tr><tr><td height="2px"></td></tr></table>'; //гостевое меню

    $html = $menu;

    $html .= '<table cellspacing="0" cellpadding="0"><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>'; //верхний итератор

    $html .= '<table cellspacing="0" cellpadding="0" width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600">
    <tr style="background-color: #98c6d2"><td height="1px"></td></tr><tr><td height="10px"></td></tr>
    <tr><td><div title="Название топика" align="center">'.$name.'</div></td></tr><tr><td height="12px"></td></tr></table>'; //заголовок страницы

    $html .= '<table width="100%" cellspacing="0" cellpadding="0">
    <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений

    //шаблон строки таблицы
    $template = '<tr><td><a name="{id_msg}"></a></td></tr><tr style="background-color: #f5f5f5">
    <td width="15%" valign="top" align="center">
    <div style="min-height: 21px"><div style="padding-top:3px">
    <a title="Перейти на страницу участника" style="font-size: 15px; font-weight: 600" href="./?ai=50&id={id}">{name}</a></div></div>
      <div style="margin-top: 5px">{avatar}</div>
      <div style="font-size: 14px" title="Статус">{status}</div>
    </td>
    <td width="85%">
      <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
      <td width="100%" align="left"><span title="Название топика" style="padding-left:6px;font-size:12px;color:#585858">'.$name.'</span></td></tr></table></div>
      <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
      <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
      <td width="1%"></td>
      <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
      <td width="45%"></td>
      <td width="20%" align="right"><a title="Ссылка на сообщение" style="padding-right:4px;font-size:14px" href="./?ai=9&msg={id_msg}#{id_msg}">№{id_msg}</a></td>
      </tr></table></div>
      <div class="message">{message}</div>
      <div><table width="100%" height="26px" cellspacing="0" cellpadding="0"><tr><td align="right">{niz}</td></tr></table></div>
    </td></tr>
    <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; 

    $stmt = mysqli_prepare($GLOBALS['DB'],
    'SELECT posts.id_msg, posts.createtime, posts.edittime, posts.text, posts.id_author, posts.likes, posts.disagrees,
     users.name, users.avatar, users.status
     FROM posts
     LEFT JOIN users ON posts.id_author = users.iduser
     LEFT JOIN likes ON posts.id_msg = likes.id_msg AND likes.id_from = ?
     WHERE posts.id_topic=? AND posts.deleted=0
     ORDER BY posts.id_msg ASC
     LIMIT '."$Showmsgs".' OFFSET '."$Offset"); //берём все сообщения топика, сортируя от свежих к старым
    mysqli_stmt_bind_param($stmt, 'ii', intval($_COOKIE['iduser']), intval($topicid));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_msg, $createtime, $edittime, $text, $id_author, $likes, $disagrees, $username, $avatar, $status);

    while (mysqli_stmt_fetch($stmt)){
      $row = $template; //копируем шаблон строки

      if (!empty($avatar)) //если аватар есть - выводим его
      $row = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $row); 
      else $row = str_replace('{avatar}','', $row);

      $row = str_replace('{id}',$id_author, $row);
      $row = str_replace('{status}',$status, $row);
      $row = str_replace('{id_msg}',$id_msg, $row);

      $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
      if ($timezone < 0){
        $timeshift = abs($timezone);
        date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
      }else{
        date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
      }
      $createtime = date_format($date, $timeformat);
      $row = str_replace('{createtime}',$createtime, $row);

      if ($edittime != '0000-00-00 00:00:00'){
        $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $edittime = date_format($date, $timeformat);
        $row = str_replace('{edittime}',$edittime, $row);
      }else{
        $row = str_replace('{edittime}','', $row);
      }
      
      if ($likes>0) $pref1 = '+';// лайки показываем безусловно
      else $pref1 = '';
      if ($disagrees>0) $pref2 = '-';
      else $pref2 = '';
      $niz ='<div style="float:right;margin-top:5px;padding-left:5px;padding-right:5px;">'.
      '<span id="SL'.$id_msg.'" onmouseover="ShowLikes('.$id_msg.')" style="color:blue">'.$pref1.$likes.
      '</span> | <span id="SD'.$id_msg.'" onmouseover="ShowDislikes('.$id_msg.')" style="color:red">'.$pref2.$disagrees.'</span></div></div>';

      $row = str_replace('{niz}', $niz, $row);
      $row = str_replace('{name}',$username, $row);
      $row = str_replace('{message}', TagFormat($text), $row); //выводим имя и сообщение со всеми тэгами в конце, чтобы исключить риски замены данных в тексте сообщения (например, если юзер напишет {niz})

      $html .= $row;
    }
    mysqli_stmt_close($stmt);

    $html .= '</table><table cellspacing="0" cellpadding="0"><tr><td height="3px"></td></tr><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>';//нижний итератор

    $html .= $menu;

    mysqli_query($GLOBALS['DB'], 'UPDATE topics SET views=views+1 WHERE id_topic='."$topicid"); //все гости всчитываются в просмотры

  }else{ //если участник залогинен
    $msgid = (int)substr($_GET['msg'], 0, 7); // id сообщения
    if ($msgid > 0){

      $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_topic, deleted FROM posts WHERE id_msg=? LIMIT 1'); // проверка есть ли топик
      mysqli_stmt_bind_param($stmt, 'i', $msgid); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $topicid, $deleted);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);

      if (!isset($deleted)){ //если сообщение удалено физически то берём номер топика из $_GET и ищем неудалённое сообщение с максимальным номером
        $topicid = (int)substr($_GET['id'], 0, 6); // id топика

        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT MAX(id_msg) FROM posts WHERE deleted=0 AND id_topic=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', $topicid); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $msgid); 
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");//переходим на это сообщение
        else header('Location: http://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");
        exit();
      }

      if (($deleted == 1) and (!empty($topicid))){ //если сообщение удалено в ЛС, но ещё физически на сервере, ищем неудалённое сообщение с максимальным номером
        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT MAX(id_msg) FROM posts WHERE deleted=0 AND id_topic=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', $topicid); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $msgid); 
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");//переходим на это сообщение
        else header('Location: http://'.$GLOBALS['HostName'].'/?ai=9&msg='."$msgid".'#'."$msgid");
        exit();

      //  $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      //  <tr><td><div align="center">Сообщение удалено.</div></td></tr><tr><td height="10px"></td></tr></table>';
      //  return $html;
      }     

      if (empty($topicid)){ // если такого топика нет, то и такого сообщения нет
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого сообщения нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
        return $html;
      }else{// если такой топик есть выясняем номер страницы по порядковому номеру позиции сообщения в ленте топика    
        $stmt = mysqli_prepare($GLOBALS['DB'],
        'SELECT COUNT(*) FROM posts WHERE deleted=0 AND id_topic=? AND id_msg<=? ORDER BY id_msg ASC'); //выясняем порядковый номер сообщения
        mysqli_stmt_bind_param($stmt, 'ii', $topicid, $msgid);
        if(mysqli_stmt_execute($stmt)){ 
          mysqli_stmt_bind_result($stmt, $msgPos);
          mysqli_stmt_fetch($stmt);   
        }
        mysqli_stmt_close($stmt);

        $page = ceil($msgPos / $mpp); //получили номер страницы по номеру сообщения
      }
    }else{//отображение контента по номеру сообщения и по номеру страницы независимы и могут быть взаимоисключающими
      $topicid = (int)substr($_GET['id'], 0, 6); // id топика
      if ($topicid <= 0){
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого контента нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
        return $html;
      }
      $page = (int)substr($_GET['page'], 0, 7); // номер страницы 
      if ($page <= 0) $page = 1;
    }

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timevisit FROM lastvisits WHERE id_topic=? AND iduser=?');
    mysqli_stmt_bind_param($stmt, 'ii', $topicid, intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $topictimevisit); // получение времени последнего визита в топик для подсветки сообщений
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT msgs, name, id_author, type, deleted FROM topics WHERE id_topic=?');
    mysqli_stmt_bind_param($stmt, 'i', $topicid); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $Totalmsgs, $name, $idauthor, $type, $del); // получение количества сообщений всего, названия и проверка есть ли топик
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    if ($del == 1){
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Топик удалён.</div></td></tr><tr><td height="10px"></td></tr></table>';
      return $html;
    }

    if (empty($name)){
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Такого топика нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
      return $html;
    }

    $TotalPages = ceil($Totalmsgs / $mpp); //максимальный номер страницы = кол-во страниц
    if ($page > $TotalPages) $page = $TotalPages;
    if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка сообщений
      $Showmsgs = $Totalmsgs - (($TotalPages - 1) * $mpp);
    }else{ // если страница внутри итератора - длина списка равна настроечной
      $Showmsgs = $mpp;
    }
    $Offset = $mpp * ($page - 1);

    if ($TotalPages > 1){ //создаём итератор, только если страниц 2 и более
      require 'PageIteratorCreate.php';
      $PageIterator = PageIteratorCreate(27, $TotalPages, $page, './?ai=9&id='.$topicid.'&page='); //создаём html-код итератора страниц (ячейки таблицы)
      if ($page == $TotalPages){ //если текущая страница последняя показываем только стрелку "назад"
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Предыдущая страница" src="./pics/suda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page-1)."'".'" alt="Назад" style="display: block"></a></div>';
      }elseif ($page == 1){ //если текущая страница первая показываем только стрелку "вперёд"
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Следующая страница" src="./pics/tuda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=2'".'" alt="Вперёд" style="display: block"></a></div>';
      }else{//если текущая страница внутри диапазона
        $PageNav = '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Следующая страница" src="./pics/tuda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page+1)."'".'" alt="Вперёд" style="display: block"></a></div>'.
        '<div style="float: right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Предыдущая страница" src="./pics/suda.png" onclick="location.href='."'".'./?ai=9&id='.$topicid."&page=".($page-1)."'".'" alt="Назад" style="display: block"></a></div>';
      }
    }else{
      $PageIterator = '';
      $PageNav = '';
    }

    if ($idauthor != $_COOKIE['iduser']){
      $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT listid FROM wblist WHERE id_from=? AND id_to=? LIMIT 1"); //в каком списке мы у автора
      mysqli_stmt_bind_param($stmt, 'ii', $idauthor, intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $listid);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
    }else{
      $listid = 1; //мы сами у себя всегда в белом списке
    }

    $menu = '<table cellspacing="0" cellpadding="0" width="100%"><tr><td height="2px"></td></tr><tr><td>';

    if ((($userstatus == 'create') or ($userstatus == 'write')) and
      ((($type == 1)and($listid != -1)) or (($type == 2)and($listid == 1)))){ //кнопку "создать сообщение" показываем только тем, кто может ею воспользоваться
      $menu .= '<div style="float: left"><a class="noneall" href="./?ai=10&id='.$topicid.'" style="cursor: pointer"><img title="Новое сообщение" src="./pics/newmsg.png" alt="Новое сообщение" style="display: block"></a></div>';
    }

    $menu .='<div style="float: left"><a class="noneall" style="cursor:pointer">'.
    '<img title="Увеличить шрифт" src="./pics/Like.png" onclick="FontPlus()" alt="шрифт+" style="display: block"></a></div>'.
    '<div style="float: left"><a class="noneall" style="cursor:pointer">'.
    '<img title="Уменьшить шрифт" src="./pics/minus.png" onclick="FontMinus()" alt="шрифт-" style="display: block"></a></div>'. 
    '<div style="float: left"><a class="noneall" style="cursor:pointer">'.
    '<img title="Скачать топик" src="./pics/download.png" onclick="location.href='."'".'./dnldtopic.php?id='.$topicid."'".'" alt="Скачать" style="display: block"></a></div>';

    if ($idauthor == $_COOKIE['iduser']){ //кнопку "править" показываем только автору топика
      $menu .='<div style="float: left"><a class="noneall" href="./?ai=12&id='.$topicid.'" style="cursor:pointer"><img title="Редактировать топик" src="./pics/edit.png" alt="Правка" style="display: block"></a></div>';
    }else{ //другим показываем кнопку "подать жалобу"
      if ($userstatus == 'create') //показываем кнопку "подать жалобу"
      $menu .='<div style="float: left"><a class="noneall" style="cursor:pointer">'.
      '<img title="Подать жалобу на топик" onclick="openForm(2,'."'".$name."'".','.$topicid.')" src="./pics/sclaiml.png" alt="Жалоба" style="display: block"></a></div>';
    }

    if (($idauthor == $_COOKIE['iduser'])or($admin == 1)) { //кнопку "удалить" показываем только автору топика и админам
      $menu .='<div style="float: left"><a class="noneall" style="cursor:pointer"><img title="Удалить топик" onclick="DelTopic('.$topicid.')" src="./pics/delete.png" alt="Удалить" style="display: block"></a></div>';
    }

    $menu .= $PageNav.'</td></tr><tr><td height="2px"></td></tr></table>'; // меню топика

    $html = $menu;

    $html .= '<table cellspacing="0" cellpadding="0"><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>'; //верхний итератор

    //заголовок страницы
    $html .= '<table cellspacing="0" cellpadding="0" width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600">
    <tr style="background-color: #98c6d2"><td height="1px"></td></tr><tr><td height="10px"></td></tr>
    <tr><td><div title="Название топика" align="center">'.$name.'</div></td></tr><tr><td height="12px"></td></tr></table>';

    $html .= '<table width="100%" cellspacing="0" cellpadding="0">
    <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений

    //шаблон строки таблицы
    $template = '<tr><td><a name="{id_msg}"></a></td></tr>{hidebut}
    <tr {hidestyle}><td width="15%" valign="top" align="center">
      <div style="min-height: 21px"><div style="padding-top:3px">
      <a title="Перейти на страницу участника" style="font-size: 15px; font-weight: 600" href="./?ai=50&id={id}">{name}</a></div></div>
      <div style="margin-top: 5px">{avatar}</div>
      <div style="font-size: 14px" title="Статус">{status}</div>
    </td>
    <td width="85%">
      <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
      <td width="100%" align="left"><span title="Название топика" style="padding-left:6px;font-size:12px;color:#585858">'.$name.'</span>{newmsg}</td></tr></table></div>
      <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
      <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
      <td width="1%"></td>
      <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
      <td width="45%"></td>
      <td width="20%" align="right"><a title="Ссылка на сообщение" style="padding-right:4px;font-size:14px" href="./?ai=9&msg={id_msg}#{id_msg}">№{id_msg}</a></td>
      </tr></table></div>
      <div class="message">{message}</div>
      <div><table width="100%" height="26px" cellspacing="0" cellpadding="0"><tr><td align="right">{niz}</td></tr></table></div>
    </td></tr>
    <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>';

    $bl = array(); // строим чёрный список
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_to FROM wblist WHERE id_from=? AND listid=-1');
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_to);
    while (mysqli_stmt_fetch($stmt)){
      array_push($bl, $id_to);
    }
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'],
    'SELECT posts.id_msg, posts.createtime, posts.edittime, posts.text, posts.id_author, posts.likes, posts.disagrees,
     users.name, users.avatar, users.status, likes.value
     FROM posts
     LEFT JOIN users ON posts.id_author = users.iduser
     LEFT JOIN likes ON posts.id_msg = likes.id_msg AND likes.id_from = ?
     WHERE posts.id_topic=? AND posts.deleted=0
     ORDER BY posts.id_msg ASC
     LIMIT '."$Showmsgs".' OFFSET '."$Offset"); //берём все сообщения топика, сортируя от свежих к старым
    mysqli_stmt_bind_param($stmt, 'ii', intval($_COOKIE['iduser']), intval($topicid));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_msg, $createtime, $edittime, $text, $id_author, $likes, $disagrees,
     $username, $avatar, $status, $like_value);

    while (mysqli_stmt_fetch($stmt)){
      $row = $template; //копируем шаблон строки

      if (!empty($avatar)) //если аватар есть - выводим его
      $row = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $row); 
      else $row = str_replace('{avatar}','', $row);

      $row = str_replace('{id}',$id_author, $row);
      $row = str_replace('{status}',$status, $row);
      $row = str_replace('{id_msg}',$id_msg, $row);

      if (strtotime($createtime) > strtotime($topictimevisit)){
        $row = str_replace('{newmsg}', '<div style="float:right"><img src="./pics/new.png" alt="new" title="Новое сообщение"></div>', $row);
      }else{
        $row = str_replace('{newmsg}', '', $row);
      }

      $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
      if ($timezone < 0){
        $timeshift = abs($timezone);
        date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
      }else{
        date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
      }
      $createtime = date_format($date, $timeformat);
      $row = str_replace('{createtime}',$createtime, $row);

      if ($edittime != '0000-00-00 00:00:00'){
        $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $edittime = date_format($date, $timeformat);
        $row = str_replace('{edittime}',$edittime, $row);
      }else{
        $row = str_replace('{edittime}','', $row);
      }
           
      $niz = '';
      if (($idauthor == $_COOKIE['iduser'])or($id_author == $_COOKIE['iduser'])or($admin == 1)){ //кнопку "удалить" показываем автору сообщения, автору топика и админам
        $niz .= '<div style="float:right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Удалить сообщение" onclick="DelMsg('.$id_msg.')" src="./pics/delete.png" alt="Удалить"></a></div>';
      }

      if (($userstatus == 'create')and($idauthor != $_COOKIE['iduser'])and($id_author != $_COOKIE['iduser'])){ // показываем кнопку "подать жалобу"
        $niz .= '<div style="float:right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Подать жалобу на сообщение" onclick="openForm(3,'."'".'№'.$id_msg."'".','.$id_msg.')" src="./pics/sclaiml.png" alt="Жалоба"></a></div>';
      } 

      if ((($userstatus == 'create') or ($userstatus == 'write')) and ((($type == 1)and($listid != -1)) or (($type == 2)and($listid == 1)))){ 
        $niz .= '<div style="float:right"><a class="noneall" href="./?ai=10&id='.$topicid.'&msg='.$id_msg.'" style="cursor: pointer"><img title="Цитата" src="./pics/quote.png" alt="Цитата"></a></div>';        
      }

      if ($id_author == $_COOKIE['iduser']){
        $niz .= '<div style="float:right"><a class="noneall" href="./?ai=11&id='.$id_msg.'" style="cursor: pointer"><img title="Правка" src="./pics/edit.png" alt="Правка"></a></div>';
      }

      if ((($userstatus == 'create') or ($userstatus == 'write')) and //кнопки лайк/дизлайк
      ($id_author != $_COOKIE['iduser']) and
      (!isset($like_value)) and
      ((($type == 1)and($listid != -1)) or (($type == 2)and($listid == 1)))){ 
        $niz .='<div style="float:right" id="L'.$id_msg.'"><div style="float:right">'.
        '<a class="noneall" style="cursor: pointer"><img title="Не нравится" onclick="Like('.$id_msg.',-1)" src="./pics/Disagree.png" alt="Нет"></a></div>'.
        '<div style="float:right"><a class="noneall" style="cursor: pointer"><img title="Нравится" onclick="Like('.$id_msg.',1)" src="./pics/Like.png" alt="Лайк"></a></div>';       
      }

      if (isset($like_value)){ //если мы ставили лайк/дизлайк, то даём возможность его отозвать
        if ($like_value == 1){ //если поставили лайк
          $likecur = 'pointer';
          $discur = 'text';
          $unlike = 'onclick="Unlike('.$id_msg.')"';
          $undislike = '';
        }else{//если поставили дизлайк
          $likecur = 'text';
          $discur = 'pointer';
          $undislike = 'onclick="Unlike('.$id_msg.')"';
          $unlike = '';
        }
      }else{ //если мы не ставили лайк/дизлайк, то показываем стандартный курсор
        $likecur = 'text';
        $discur = 'text';
        $unlike = '';
        $undislike = '';
      }

      if ($likes>0) $pref1 = '+';// лайки показываем безусловно
      else $pref1 = '';
      if ($disagrees>0) $pref2 = '-';
      else $pref2 = '';
      $niz .='<div id="L'.$id_msg.'" style="float:right;margin-top:5px;padding-left:5px;padding-right:5px">'.
      '<span id="SL'.$id_msg.'" onmouseover="ShowLikes('.$id_msg.')" '.$unlike.' style="color:blue; cursor:'.$likecur.'">'.$pref1.$likes.
      '</span> | <span id="SD'.$id_msg.'" onmouseover="ShowDislikes('.$id_msg.')" '.$undislike.' style="color:red; cursor:'.$discur.'">'.$pref2.$disagrees.'</span></div></div>';

      /*
      if ((($userstatus == 'create') or ($userstatus == 'write')) and //кнопки лайк/дизлайк
      ($id_author != $_COOKIE['iduser']) and
      (!isset($id_like)) and
      ((($type == 1)and($listid != -1)) or (($type == 2)and($listid == 1)))){ 
        $niz .='<div style="float:right" id="L'.$id_msg.'"><div style="float:right">'.
        '<a class="noneall" style="cursor: pointer"><img title="Не нравится" onclick="Like('.$id_msg.',-1)" src="./pics/Disagree.png" alt="Нет"></a></div>'.
        '<div style="float:right"><a class="noneall" style="cursor: pointer"><img title="Нравится" onclick="Like('.$id_msg.',1)" src="./pics/Like.png" alt="Лайк"></a></div></div>';       
      }
      if (($id_author == $_COOKIE['iduser']) or isset($id_like)){ //автору сообщения и проголосовавшим показываем результат лайков безусловно
        if ($likes>0) $pref1 = '+';
        else $pref1 = '';
        if ($disagrees>0) $pref2 = '-';
        else $pref2 = '';
        $niz .='<div style="float:right;margin-top:5px;padding-left:5px;padding-right:5px;">'.
        '<span id="SL'.$id_msg.'" onmouseover="ShowLikes('.$id_msg.')" style="color:blue">'.$pref1.$likes.
        '</span> | <span id="SD'.$id_msg.'" onmouseover="ShowDislikes('.$id_msg.')" style="color:red">'.$pref2.$disagrees.'</span></div>';
      }
      */

      $row = str_replace('{niz}', $niz, $row);

      if (in_array($id_author, $bl, true)){ // если автор в чёрном списке - скрываем его сообщение
        $hidebut = '<tr><td colspan="2"><div width="100%"><input type="button" id="idbut'.$id_msg.'" style="width:70px;display:inline-block;margin-left: 19px;"
         value="Показать" onclick="ShowHide('.$id_msg.', this.id)"> &nbsp; сообщение от '.$username.'</div></td></tr>';
        $row = str_replace('{hidebut}', $hidebut, $row);
        $row = str_replace('{hidestyle}', 'style="background-color: #d5d5d5;display:none" id='.$id_msg, $row);
      }else{
        $row = str_replace('{hidebut}', '', $row);
        $row = str_replace('{hidestyle}', 'style="background-color: #f5f5f5"', $row);
      }

      $row = str_replace('{name}',$username, $row);
      $row = str_replace('{message}', TagFormat($text), $row); //выводим имя и сообщение со всеми тэгами в конце, чтобы исключить риски замены данных в тексте сообщения (например, если юзер напишет {niz})

      $html .= $row;
    }
    mysqli_stmt_close($stmt);

    $html .= '</table>
    <script>function ShowHide(id,idbut){if(document.getElementById(id).style.display == "none"){'.
    'document.getElementById(id).style.display = ""; document.getElementById(idbut).value = "Скрыть";'.
    '}else{document.getElementById(id).style.display = "none"; document.getElementById(idbut).value = "Показать";};}
    function DelMsg(idmsg){if(confirm("Вы уверены, что хотите удалить данное сообщение?")){var data="ai=8&id="+encodeURIComponent(idmsg);AsyncAct(data);}}
    function DelTopic(idtopic){if(confirm("Вы уверены, что хотите удалить данный топик?")){var data="ai=9&id="+encodeURIComponent(idtopic);AsyncAct(data);}}
    function Like(idmsg,val){var data="ai=7&idmsg="+encodeURIComponent(idmsg)+"&value="+encodeURIComponent(val);AsyncAct(data);}
    function ShowLikes(idmsg){var data="ai=10&id=0&msg="+encodeURIComponent(idmsg);AsyncAct(data);}    
    function ShowDislikes(idmsg){var data="ai=10&id=1&msg="+encodeURIComponent(idmsg);AsyncAct(data);}
    function Unlike(idmsg){var data="ai=14&idmsg="+encodeURIComponent(idmsg);AsyncAct(data);}

    function setFontSizeCookie(fontSize){document.cookie = "fontSize=" + encodeURIComponent(fontSize) + "; expires=Fri, 31 Dec 9999 23:59:59 GMT; path=/";}

    function FontPlus(){var fontSizeCookie = getFontSizeFromCookie();
      var numericValue = parseInt(fontSizeCookie);
      numericValue += 1;
      var newFontSize = numericValue.toString() + "px";
      SetMessageFont(newFontSize);setFontSizeCookie(newFontSize);}
 
     function FontMinus(){var fontSizeCookie = getFontSizeFromCookie();
      var numericValue = parseInt(fontSizeCookie);
      numericValue -= 1;
      var newFontSize = numericValue.toString() + "px";
      SetMessageFont(newFontSize);setFontSizeCookie(newFontSize);}
    </script>
    <table cellspacing="0" cellpadding="0"><tr><td height="3px"></td></tr><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>';//нижний итератор

    $html .= $menu;

    if ($page == $TotalPages){ //помечаем топик прочитанным и запоминаем время визита, только если открыта последняя страница топика
      $stmt = mysqli_prepare($GLOBALS['DB'], 'DELETE FROM newmsgs WHERE id_topic=? AND iduser=?');
      mysqli_stmt_bind_param($stmt, 'ii', $topicid, intval($_COOKIE['iduser'])); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);

      $lastvisit = date('Y-m-d H:i:s'); //текущее серверное время
      if (empty($topictimevisit)){ //если записи в базе нет - создаём её
        $stmt = mysqli_prepare($GLOBALS['DB'], 'INSERT INTO lastvisits SET id_topic=?, iduser=?, timevisit=?');
        mysqli_stmt_bind_param($stmt, 'iis', $topicid, intval($_COOKIE['iduser']), $lastvisit); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_close($stmt);
      }else{ //если запись в базе есть - обновляем её
        $stmt = mysqli_prepare($GLOBALS['DB'], 'UPDATE lastvisits SET timevisit=? WHERE id_topic=? AND iduser=?');
        mysqli_stmt_bind_param($stmt, 'sii', $lastvisit, $topicid, intval($_COOKIE['iduser'])); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_close($stmt);
      }
    }

    if ($idauthor != $_COOKIE['iduser']){ //просмотры автора топика в смотры не всчитываются
      mysqli_query($GLOBALS['DB'], 'UPDATE topics SET views=views+1 WHERE id_topic='."$topicid");
    }    
  }
  $_SESSION['topictitle'] = $name.'_'.str_pad($page, 4, '0', STR_PAD_LEFT);
  return $html;
}
?>