<?php
function ShowUsersList()
{
$template = file_get_contents('./templates/UsersList.html');

if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
$stmt = mysqli_prepare($GLOBALS['DB'], "SELECT timezone, timeformat FROM users WHERE iduser=? LIMIT 1");
mysqli_stmt_bind_param($stmt, "i", intval($_COOKIE['iduser']));
mysqli_stmt_execute($stmt);
mysqli_stmt_bind_result($stmt, $timezone, $timeformat);
mysqli_stmt_fetch($stmt);
mysqli_stmt_close($stmt);
}else{
  $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
  if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
  $timeformat = 'H:i d.m.Y';
}

$stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT iduser, name, avatar, topics, posts, status,
 showonline, regtime, timevisit FROM users WHERE deleted=0 ORDER BY name'); //берём данные всех пользователей
mysqli_stmt_execute($stmt);
mysqli_stmt_bind_result($stmt, $iduser, $name, $avatar, $topics, $posts, $status, $showonline, $regtime, $timevisit);
mysqli_stmt_store_result($stmt);
$num = mysqli_stmt_num_rows($stmt);

$html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="5px"></td></tr>
<tr><td><div align="center">Всего участников: '.$num.'</div></td></tr><tr><td></td></tr></table><hr>';

while (mysqli_stmt_fetch($stmt)){
  $num = $num - 1;
  $temp = $template;

  if (!empty($avatar)) //если аватар есть - выводим его
    $temp = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $temp); 
  else $temp = str_replace('{avatar}','', $temp);

  if ($_COOKIE['iduser'] == $iduser){
    $pm = '';
  }else{
    $pm = '<a class="noneall" href="./?ai=20&id={id}"><img title="Написать личное сообщение" src="./pics/pm.png" alt="Личное сообщение"></a>';
  }
  $temp = str_replace('{pm}', $pm, $temp);

  $temp = str_replace('{id}',$iduser, $temp);
  $temp = str_replace('{name}',$name, $temp);
  $temp = str_replace('{topics}','Топиков: '.$topics, $temp);
  $temp = str_replace('{messages}','Сообщений: '.$posts, $temp);
  $temp = str_replace('{status}','Статус: '.$status, $temp);

  $nowtime = strtotime(date('Y-m-d H:i:s')); //берём текущее время и преобразуем в метку времени Unix

  $daysonforum = round(($nowtime - strtotime($regtime))/86400, 0, PHP_ROUND_HALF_UP); //сколько дней прошло с регистрации

  if ($daysonforum == 0) $daysonforum = 1;
  $lastdigit = (int)(substr("$daysonforum", -1)); //последняя цифра
  $prelastdigit = (int)(substr("$daysonforum", -2, 1)); //предпоследняя цифра

  if (($daysonforum != 11) and ($lastdigit == 1)){ // в конце 1 кроме 11 - день
    $days = 'день';
  }elseif (($prelastdigit == 1) or ($lastdigit == 0)){ //от 10 до 20 - дней
    $days = 'дней';
  }elseif (($lastdigit > 1) and ((int)$lastdigit < 5)){ 
    $days = 'дня';
  }else{
    $days = 'дней';
  };
  $temp = str_replace('{timefromreg}','На форуме '.$daysonforum.' '.$days, $temp);
  
  if ($showonline == 1){ //если пользователь разрешил в настройках показ своего онлайн-статуса
    $lastvisit = strtotime($timevisit);
    if (($nowtime-$lastvisit)>300){ //если пользователь загружал страницы форума 5 минут назад - полагаем, что он оффлайн
      $temp = str_replace('{online}','<div><img src="./pics/offline.png" alt="offline" title="Участник оффлайн"></a>', $temp); 
    }else{ // иначе - онлайн
      $temp = str_replace('{online}','<div><img src="./pics/online.png" alt="online" title="Участник онлайн"></a>', $temp); 
    }

    $date = date_create($timevisit); //для отображения смещаем время на указанное в настройках количество часов
    if ($timezone < 0){
      $timeshift = abs($timezone);
      date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
    }else{
      date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
    }
    $timevisit = date_format($date, $timeformat);

  }else{
    $timevisit = 'недоступно';
    $temp = str_replace('{online}','<div><img src="./pics/na.png" alt="NA" title="Онлайн-статус недоступен"></a>', $temp); 
  }  
  $temp = str_replace('{lastvisit}','Визит: '.$timevisit, $temp);
  $html .= $temp;
  
  if ($num > 0) $html .= '<hr>';//к последней ячейке линию не добавляем
}
mysqli_stmt_close($stmt);

return $html;
}
?>