<?php
require 'const.php';
session_start();
if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])){ //если куки авторизации есть
  if (!isset($_POST['oldpass']) or !isset($_POST['password']) or !isset($_POST['confirm'])){//если что-то отсутствует, выдаём ошибку 
    $_SESSION['msg'] = 'Смена пароля не удалась.<br>Попробуйте позже.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
    exit();
  }
}else{
  if (!isset($_POST['hash']) or !isset($_POST['password']) or !isset($_POST['confirm'])){//если что-то отсутствует, выдаём ошибку 
    $_SESSION['msg'] = 'Смена пароля не удалась.<br>Попробуйте позже.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
    exit();
  }
}
//Обрезаем переменные до длины, указанной в параметре maxlength тега input
$password = substr($_POST['password'], 0, 100);
$confirm = substr($_POST['confirm'], 0, 100);
// удаляем лишние символы
$password = trim($password);
$confirm = trim($confirm);
// Проверяем все ошибки
$error = '';
$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])){ //если куки авторизации есть
    $hash = $_COOKIE['hash'];
    $oldpass = substr($_POST['oldpass'], 0, 100);
    $oldpass = trim($oldpass);

    $stmt = mysqli_prepare($DB, 'SELECT pass FROM users WHERE user_hash=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 's', $hash);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $dbpass);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    if ($dbpass !== md5(md5($oldpass))) $error .= '<li>Текущий пароль введён неверно</li>'."\n";
  }else{
    $hash = substr($_POST['hash'], 0, 32);
    if (empty($hash)){
      $error .= '<li>Не задан идентификатор участника</li>'."\n";
    }else{
      $stmt = mysqli_prepare($DB, 'SELECT iduser FROM users WHERE user_hash=?');
      mysqli_stmt_bind_param($stmt, 's', $hash);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_store_result($stmt);
      $num = mysqli_stmt_num_rows($stmt);
      mysqli_stmt_close($stmt);
      if ($num == 0) $error .= '<li>Идентификатор участника недействителен</li>'."\n";
    }
  }
}else $error .= '<li>Ошибка соединения с базой данных: '.mysqli_connect_error().'</li>'."\n";
mysqli_close($DB);

if (empty($password)) $error .= '<li>Пароль не может быть пустым</li>'."\n";
if (empty($confirm)) $error .= '<li>Подтверждение пароля не может быть пустым</li>'."\n";
if (!empty($password) and !empty($confirm) and $password!=$confirm) $error .= '<li>Пароли не совпадают</li>'."\n";  

// Если есть хотя бы одна ошибка - сохраняем её в глобальном массиве вместе с хэшем и снова запускаем форму
if (!empty($error)){
  $_SESSION['NewPassForm'] = array();
  $_SESSION['NewPassForm']['Error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
  $_SESSION['NewPassForm']['Hash'] = "$hash";

  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=101');
  else header('Location: http://'.$HostName.'/?ai=101');
  exit();
}

require 'GenerateCode.php';
$newhash = md5(GenerateCode(10)); // генерируем случайную строку и шифруем её (хэш для куков авторизации, активации по email и смены пароля) 
$md5password = md5(md5("$password")); //дважды шифруем новый пароль c принудительным приведением типов на случай если пароль только из цифр

// если все поля заполнены правильно - меняем в базе пароль и хэш авторизации
$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname); 
  $stmt = mysqli_prepare($DB, 'UPDATE users SET pass=?, user_hash=? WHERE user_hash=?');
  mysqli_stmt_bind_param($stmt, 'sss', $md5password, $newhash, $hash);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);
  if (empty($dber)) {$_SESSION['msg'] = 'Пароль успешно изменён.<br>Теперь Вы можете войти в свою учётную запись.';}
  else {$_SESSION['msg'] = 'Смена пароля не удалась. Ошибка: '.$dber.'<br>Попробуйте позже.';}
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
}
mysqli_close($DB);  

if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
else header('Location: http://'.$HostName.'/?ai=200');  
?>