<?php
require 'const.php';
require 'GenerateCode.php';
session_start();

if (!isset($_POST['name']) or //если что-то отсутствует, запускаем форму настроек
    !isset($_POST['email']) or
    !isset($_POST['mpp']) or
    !isset($_POST['tpp']) or
    !isset($_POST['timeformat']) or
    !isset($_POST['password']))
{
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=4');
  else header('Location: http://'.$HostName.'/?ai=4');
  exit();
}

if (!isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован то перенаправляем на начальную страницу
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false)
{
mysqli_select_db($DB, $DBname); 

//обрезаем переменные по длине и проверяем
  $name = substr($_POST['name'], 0, 100);
  $name = trim($name);
  $email = substr($_POST['email'], 0, 129);
  $email = trim($email);
  $email = mb_strtolower($email); //приводим адрес почты к нижнему регистру
  $about = substr($_POST['about'], 0, 1000);
  $timeformat = substr($_POST['timeformat'], 0, 20);
  $timezone = (int)$_POST['timezone'];
  if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
  $tpp = (int)$_POST['tpp'];
  if (($tpp < 1) or ($tpp > 16777215)) $tpp = 20;
  $mpp = (int)$_POST['mpp'];
  if (($mpp < 1) or ($mpp > 16777215)) $mpp = 20;
  if (isset($_POST['showonline']) == true) {$showonline = true;}else {$showonline = false;}
  if (isset($_POST['mailpmnotice']) == true) {$mailpmnotice = true;}else {$mailpmnotice = false;}
  $password = substr($_POST['password'], 0, 100);
  $password = trim($password);
  
  // Проверяем все ошибки
  $error = '';
  if (empty($name)) $error .= '<li>Отображаемое имя не может быть пустым</li>'."\n";
  if (empty($email)) $error .= '<li>Адрес электронной почты не может быть пустым</li>'."\n"; 
  if (empty($password)) $error .= '<li>Пароль не может быть пустым</li>'."\n";
  // проверка корректности e-mail
  if (!empty($email) and !preg_match( "#^[0-9a-z_\-\.]+@[0-9a-z\-\.]+\.[a-z]{2,6}$#i", $email))
    $error .= '<li>Адрес электронной почты должен быть в формате name@host.xyz</li>'."\n";

  if (mb_strlen($_POST['about'],'UTF-8')>1000) $error .= '<li>"О себе" не может превышать 1000 символов</li>'."\n";

  $date = date_create('2021-01-30 17:03:31'); //случайная дата для теста
  $timetest = date_format($date, $timeformat);
  if (($timetest == $timeformat) or empty($timeformat)) $error .= '<li>Неверный формат времени</li>'."\n";

  //проверка на правильно введённый пароль, заодно берём ассоциированную почту, аватар и коды
  $stmt = mysqli_prepare($DB, 'SELECT pass, email, smscode, emailcode, avatar, status FROM users WHERE user_hash=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 's', $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $passDB, $emailDB, $smscode, $emailcode, $avatar, $status);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if (md5(md5("$password")) !== $passDB) $error .= '<li>Введён неверный пароль</li>'."\n";

  // проверка, на дубль email
  if ($email !== $emailDB) { //если введён новый email
  $stmt = mysqli_prepare($DB, 'SELECT iduser FROM users WHERE email=?');
  mysqli_stmt_bind_param($stmt, 's', $email);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_store_result($stmt);
  $num = mysqli_stmt_num_rows($stmt);
  mysqli_stmt_close($stmt);
  if ($num > 0) $error .= '<li>Этот адрес электронной почты уже занят</li>'."\n";
  }

  //загружаем аватар
  $avatarname = $avatar;
  if ($_FILES['avatar']['error'] != 0){
    if (($_FILES['avatar']['error'] != 4)) $error .= 'Ошибка загрузки файла №: '.$_FILES['avatar']['error'];
  }else{
    if (isset($_FILES['avatar']['tmp_name'])){
      $data = file_get_contents($_FILES['avatar']['tmp_name']); //точно определяем mime-type изображения
      $finfo = finfo_open(FILEINFO_MIME_TYPE);
      $type = finfo_buffer($finfo, $data);
      finfo_close($finfo);
      switch ($type){
        case 'image/jpeg':
          $uploaded = imagecreatefromjpeg($_FILES['avatar']['tmp_name']);
          break;
        case 'image/bmp':
          $uploaded = imagecreatefrombmp($_FILES['avatar']['tmp_name']);
          break;
        case 'image/x-ms-bmp':
          $uploaded = imagecreatefrombmp($_FILES['avatar']['tmp_name']);
          break;
        case 'image/gif':
          $uploaded = imagecreatefromgif($_FILES['avatar']['tmp_name']);
          break;
        case 'image/png':
          $uploaded = imagecreatefrompng($_FILES['avatar']['tmp_name']);
          break;
        case 'image/webp':
          $uploaded = imagecreatefromwebp($_FILES['avatar']['tmp_name']);
          break;
        case 'image/vnd.wap.wbmp':
          $uploaded = imagecreatefromwbmp($_FILES['avatar']['tmp_name']);
          break;
        case 'image/xbm':
          $uploaded = imagecreatefromxbm($_FILES['avatar']['tmp_name']);
          break;
      }
      $X = imagesx($uploaded); //определяем размеры
      $Y = imagesy($uploaded);
      if (($X > 0) and ($Y > 0)){ //если размеры картинки не нулевые
        if (($X <= 100) and ($X <= 100)){//если размеры маленькие оставляем как есть
          $width = $X;
          $height = $Y;
        }else{ //если хотя бы один размер превышает 100 пикселей - ресемплим
          if ($X > $Y){$width = 100; $height = round($width*($Y/$X),0,PHP_ROUND_HALF_UP);}
          else {$height = 100; $width = round($height*($X/$Y),0,PHP_ROUND_HALF_UP);}
        }
        $im = imagecreatetruecolor($width, $height);
        imagecopyresampled($im, $uploaded, 0, 0, 0, 0, $width, $height, $X, $Y); 
        $avatarname = md5(GenerateCode(10)); 
        $avatarname = substr($avatarname, 0, 7); //ограничиваем имя файла семью случайными символами
        imagejpeg($im,'avatars/'."$avatarname".'.jpg', 95);
        imagedestroy($im);
      }
    }
  }
  if ($avatarname !== $avatar){
    $path = 'avatars/'."$avatar".'.jpg';
    if (file_exists($path)) unlink($path); //удаляем старый файл аватара если он есть
  } 

  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля и снова запускаем форму
  if (!empty($error)){
    $_SESSION['AccountForm'] = array();
    $_SESSION['AccountForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['AccountForm']['name'] = $name;
    $_SESSION['AccountForm']['email'] = $email;
    $_SESSION['AccountForm']['avatar'] = $avatarname; //если аватар был загружен он сразу и обновляется
    $_SESSION['AccountForm']['about'] = $about;
    $_SESSION['AccountForm']['timezone'] = $timezone;
    $_SESSION['AccountForm']['timeformat'] = $timeformat;
    $_SESSION['AccountForm']['tpp'] = $tpp;
    $_SESSION['AccountForm']['mpp'] = $mpp;
    $_SESSION['AccountForm']['showonline'] = $showonline;
    $_SESSION['AccountForm']['mailpmnotice'] = $mailpmnotice;
    $_SESSION['AccountForm']['password'] = $password;
    $_SESSION['AccountForm']['smscode'] = $smscode;
    $_SESSION['AccountForm']['emailcode'] = $emailcode;
    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=4');
    else header('Location: http://'.$HostName.'/?ai=4');
    exit();
  }
 
  // если все поля заполнены правильно - обновляем в базе данные участника
  $stmt = mysqli_prepare($DB, 'UPDATE users SET name=?, email=?, about=?, timeformat=?, timezone=?, tpp=?, mpp=?, showonline=?, mailpmnotice=?, avatar=? WHERE user_hash=?');
  mysqli_stmt_bind_param($stmt, 'ssssiiiiiss', $name, $email, $about, $timeformat, $timezone, $tpp, $mpp, $showonline, $mailpmnotice, $avatarname, $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);

  if ($email !== $emailDB) { //если введён новый email сбрасываем индикатор активации и меняем статус
    if ($status == 'create') $newstatus = 'write';
    else $newstatus = 'readonly';
    $stmt = mysqli_prepare($DB, "UPDATE users SET emailcode='0', status=? WHERE user_hash=?");
    mysqli_stmt_bind_param($stmt, 'ss', $newstatus, $_COOKIE['hash']);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_close($stmt);
  }

  if (empty($dber)){$_SESSION['UpdateSuccess'] = 'Данные учётной записи успешно обновлены<br><br>';}
  else {$_SESSION['UpdateSuccess'] = 'Возникла ошибка: '.$dber.'<br>Попробуйте позже.<br><br>';}

  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=4');
    else header('Location: http://'.$HostName.'/?ai=4');

mysqli_close($DB);
}
?>